<?php
/**
 * Plugin mod_rewrite backend include file to administer settings (in content frame)
 *
 * @date        22.04.2008
 * @author      Murat Purc
 * @copyright    Murat Purc 2008
 * @package     Contenido
 * @subpackage  ModRewrite
 */

defined('CON_FRAMEWORK') or die('Illegal call');

$action = (isset($_REQUEST['mr_action'])) ? $_REQUEST['mr_action'] : 'index';
$debug  = false;

//var_dump($cfg['templates']['mod_rewrite_content']);


####################################################################################################
##### Some variables


$oGlob  = mpGlobals::getInstance();
$oTpl   = new Template();
$aMrCfg = ModRewrite::getConfig();

// downwards compatibility to previous plugin versions
if (mr_arrayValue($aMrCfg, 'category_seperator', '') == '') {
    $aMrCfg['category_seperator'] = '/';
}
if (mr_arrayValue($aMrCfg, 'category_word_seperator', '') == '') {
    $aMrCfg['category_word_seperator'] = '-';
}
if (mr_arrayValue($aMrCfg, 'article_seperator', '') == '') {
    $aMrCfg['article_seperator'] = '/';
}
if (mr_arrayValue($aMrCfg, 'article_word_seperator', '') == '') {
    $aMrCfg['article_word_seperator'] = '-';
}

// some settings
$aBgColor = array(
    'enabled'  => '#ffffff',
    'disabled' => '#dadada'
);
$aSeparator = array(
    'pattern'         => '/^[\/\-_\.\$~]{1}$/',
    'info'            => '<span style="font-family:courier;font-weight:bold;">/ - . _ ~</span>'
);
$aWordSeparator = array(
    'pattern'         => '/^[\-_\.\$~]{1}$/',
    'info'            => '<span style="font-family:courier;font-weight:bold;">- . _ ~</span>'
);

$routingSeparator = '>>>';

// define basic data contents (used for template)
$aData = array();
$aData['PLUGIN_PATH']      = mpGlobals::getInstance()->get('cfg/path/plugins') . 'mod_rewrite/';
$aData['CONTENT.BEFORE']   = '';
$aData['SESSID']           = $sess->id;
$aData['AREA']             = $area;
$aData['ACTION']           = $action;
$aData['IDCLIENT']         = $client;
$aData['USE_CHK']          = (ModRewrite::isEnabled()) ? ' checked="checked"' : '';
$aData['BGCOLOR_ENABLED']  = $aBgColor['enabled'];
$aData['BGCOLOR_DISABLED'] = $aBgColor['disabled'];

// mr root dir
$aData['ROOTDIR']       = $aMrCfg['rootdir'];
$aData['ROOTDIR_ERROR'] = '';

// mr check root dir
$aData['CHECKROOTDIR_CHK'] = ($aMrCfg['checkrootdir'] == 1) ? ' checked="checked"' : '';

// mr start from root
$aData['STARTFROMROOT_CHK'] = ($aMrCfg['startfromroot'] == 1) ? ' checked="checked"' : '';

// mr prevent duplicated content
$aData['PREVENT_DUPLICATED_CONTENT_CHK'] = ($aMrCfg['prevent_duplicated_content'] == 1) ? ' checked="checked"' : '';

// mr language usage
$aData['USE_LANGUAGE_CHK']           = ($aMrCfg['use_language'] == 1) ? ' checked="checked"' : '';
$aData['USE_LANGUAGE_NAME_CHK']      = ($aMrCfg['use_language_name'] == 1) ? ' checked="checked"' : '';
$aData['USE_LANGUAGE_NAME_DISABLED'] = ($aMrCfg['use_language'] == 1) ? '' : ' disabled="disabled"';

// mr client usage
$aData['USE_CLIENT_CHK']           = ($aMrCfg['use_client'] == 1) ? ' checked="checked"' : '';
$aData['USE_CLIENT_NAME_CHK']      = ($aMrCfg['use_client_name'] == 1) ? ' checked="checked"' : '';
$aData['USE_CLIENT_NAME_DISABLED'] = ($aMrCfg['use_client'] == 1) ? '' : ' disabled="disabled"';

// mr lowecase uri
$aData['USE_LOWERCASE_URI_CHK']         = ($aMrCfg['use_lowercase_uri'] == 1) ? ' checked="checked"' : '';

// mr category/category word separator
$aData['CATEGORY_SEPARATOR']             = $aMrCfg['category_seperator'];
$aData['CATEGORY_SEPARATOR_ATTRIB']      = '';
$aData['CATEGORY_WORD_SEPARATOR']        = $aMrCfg['category_word_seperator'];
$aData['CATEGORY_WORD_SEPARATOR_ATTRIB'] = '';
$aData['CATEGORY_SEPARATOR_ERROR']      = '';
$aData['CATEGORY_WORD_SEPARATOR_ERROR'] = '';

// mr article/article word separator
$aData['ARTICLE_SEPARATOR']             = $aMrCfg['article_seperator'];
$aData['ARTICLE_SEPARATOR_ATTRIB']      = '';
$aData['ARTICLE_WORD_SEPARATOR']        = $aMrCfg['article_word_seperator'];
$aData['ARTICLE_WORD_SEPARATOR_ATTRIB'] = '';
$aData['ARTICLE_SEPARATOR_ERROR']      = '';
$aData['ARTICLE_WORD_SEPARATOR_ERROR'] = '';

$aData['CAT_ART_SEP_MSG']    = '(M&ouml;gliche Werte: ' . $aSeparator['info'] . ')';
$aData['WORD_SEPARATOR_MSG'] = '(M&ouml;gliche Werte: ' . $aWordSeparator['info'] . ')';

// mr file extension
$aData['FILE_EXTENSION']       = $aMrCfg['file_extension'];
$aData['FILE_EXTENSION_ERROR'] = '';

// mr category name resolve percentage
$aData['CATEGORY_RESOLVE_MIN_PERCENTAGE']       = $aMrCfg['category_resolve_min_percentage'];
$aData['CATEGORY_RESOLVE_MIN_PERCENTAGE_ERROR'] = '';

// mr add start article name to url
$aData['ADD_STARTART_NAME_TO_URL_CHK']   = ($aMrCfg['add_startart_name_to_url'] == 1) ? ' checked="checked"' : '';
$aData['ADD_STARTART_NAME_TO_URL_ERROR'] = '';
$aData['DEFAULT_STARTART_NAME']          = $aMrCfg['default_startart_name'];

// mr rewrite urls at
$aData['REWRITE_URLS_AT_CONGENERATECODE_CHK']      = ($aMrCfg['rewrite_urls_at_congeneratecode'] == 1) ? ' checked="checked"' : '';
$aData['REWRITE_URLS_AT_FRONT_CONTENT_OUTPUT_CHK'] = ($aMrCfg['rewrite_urls_at_front_content_output'] == 1) ? ' checked="checked"' : '';
$aData['CONTENT.AFTER'] = '';

// mr rewrite routing
$data = '';
if (is_array($aMrCfg['routing'])) {
    foreach ($aMrCfg['routing'] as $uri => $route){
        $data .= $uri . $routingSeparator . $route . "\n";
    }
}
$aData['REWRITE_ROUTING'] = $data;

// mr redirect invalid article
$aData['REDIRECT_INVALID_ARTICLE_TO_ERRORSITE_CHK'] = ($aMrCfg['redirect_invalid_article_to_errorsite'] == 1) ? ' checked="checked"' : '';


####################################################################################################
##### Action processing

if ($action == 'index') {

    _actionIndex();

} elseif ($action == 'save') {

    _actionSave();

} elseif ($action == 'reset') {

    _actionReset();

}


// Loop data array, fill'n output template
foreach ($aData as $p => $v) {
    $oTpl->set('s', $p, $v);
}
$oTpl->generate(
    $oGlob->get('cfg/path/contenido') . $oGlob->get('cfg/path/plugins') . 'mod_rewrite/templates/content.html', 0, 0
);


####################################################################################################
##### Functions

function _actionIndex(){
    // donut
}


function _actionSave(){

    $oGlob  = mpGlobals::getInstance();
    $cfg    = $oGlob->get('cfg');
    $aData  = $oGlob->get('aData');

    $bError = false;

    $request = (count($_POST) > 0) ? $_POST : $_GET;
    mr_requestCleanup($request);

    // use mod_rewrite
    if (mr_arrayValue($request, 'use') == 1) {
        $aData['USE_CHK'] = ' checked="checked"';
        $aMR['mod_rewrite']['use'] = 1;
    } else {
        $aData['USE_CHK'] = '';
        $aMR['mod_rewrite']['use'] = 0;
    }

    // root dir
    if (mr_arrayValue($request, 'rootdir', '') !== '') {
        if (!preg_match('/^[a-zA-Z0-9\-_\/\.]*$/', $request['rootdir'])) {
            $aData['ROOTDIR_ERROR'] = _notifyBox('error', 'Das Rootverzeichnis hat ein ung&uuml;ltiges Format, erlaubt sind die Zeichen [a-zA-Z0-9\-_\/\.]');
            $bError = true;
        } elseif (!is_dir($_SERVER['DOCUMENT_ROOT'] . $request['rootdir'])) {

            if (mr_arrayValue($request, 'checkrootdir') == 1) {
                // root dir check is enabled, this results in error
                $aData['ROOTDIR_ERROR'] = _notifyBox('error', 'Das angegebene Verzeichnis "' . $_SERVER['DOCUMENT_ROOT'] . $request['rootdir'] . '" existiert nicht');
                $bError = true;
            } else {
                // root dir check ist disabled, take over the setting and output a warning.
                $aData['ROOTDIR_ERROR'] = _notifyBox('warning', 'Das angegebene Verzeichnis "' . $request['rootdir'] . '" existiert nicht im aktuellen DOCUMENT_ROOT "' . $_SERVER['DOCUMENT_ROOT'] . '". Das kann vorkommen, wenn das DOCUMENT_ROOT des Clients vom Contenido Backend DOCUMENT_ROOT abweicht. Die Einstellung wird dennoch &uuml;bernommen, da die &Uuml;berpr&uuml;fung abgeschaltet wurde');
            }
        }
        $aData['ROOTDIR']              = htmlentities($request['rootdir']);
        $aMR['mod_rewrite']['rootdir'] = $request['rootdir'];
    }

    // root dir check
    if (mr_arrayValue($request, 'checkrootdir') == 1) {
        $aData['CHECKROOTDIR_CHK'] = ' checked="checked"';
        $aMR['mod_rewrite']['checkrootdir'] = 1;
    } else {
        $aData['CHECKROOTDIR_CHK'] = '';
        $aMR['mod_rewrite']['checkrootdir'] = 0;
    }

    // start from root
    if (mr_arrayValue($request, 'startfromroot') == 1) {
        $aData['STARTFROMROOT_CHK']          = ' checked="checked"';
        $aMR['mod_rewrite']['startfromroot'] = 1;
    } else {
        $aData['STARTFROMROOT_CHK'] = '';
        $aMR['mod_rewrite']['startfromroot'] = 0;
    }

    // prevent duplicated content
    if (mr_arrayValue($request, 'prevent_duplicated_content') == 1) {
        $aData['PREVENT_DUPLICATED_CONTENT_CHK']          = ' checked="checked"';
        $aMR['mod_rewrite']['prevent_duplicated_content'] = 1;
    } else {
        $aData['PREVENT_DUPLICATED_CONTENT_CHK']         = '';
        $aMR['mod_rewrite']['prevent_duplicated_content'] = 0;
    }

    // language settings
    if (mr_arrayValue($request, 'use_language') == 1) {
        $aData['USE_LANGUAGE_CHK']           = ' checked="checked"';
        $aData['USE_LANGUAGE_NAME_DISABLED'] = '';
        $aMR['mod_rewrite']['use_language']  = 1;
        if (mr_arrayValue($request, 'use_language_name') == 1) {
            $aData['USE_LANGUAGE_NAME_CHK']          = ' checked="checked"';
            $aMR['mod_rewrite']['use_language_name'] = 1;
        } else {
            $aData['USE_LANGUAGE_NAME_CHK']          = '';
            $aMR['mod_rewrite']['use_language_name'] = 0;
        }
    } else {
        $aData['USE_LANGUAGE_CHK']               = '';
        $aData['USE_LANGUAGE_NAME_DISABLED']     = ' disabled="disabled"';
        $aMR['mod_rewrite']['use_language']      = 0;
        $aData['USE_LANGUAGE_NAME_CHK']          = '';
        $aMR['mod_rewrite']['use_language_name'] = 0;
    }

    // client settings
    if (mr_arrayValue($request, 'use_client') == 1) {
        $aData['USE_CLIENT_CHK']           = ' checked="checked"';
        $aData['USE_CLIENT_NAME_DISABLED'] = '';
        $aMR['mod_rewrite']['use_client']  = 1;
        if (mr_arrayValue($request, 'use_client_name') == 1) {
            $aData['USE_CLIENT_NAME_CHK']          = ' checked="checked"';
            $aMR['mod_rewrite']['use_client_name'] = 1;
        } else {
            $aData['USE_CLIENT_NAME_CHK']          = '';
            $aMR['mod_rewrite']['use_client_name'] = 0;
        }
    } else {
        $aData['USE_CLIENT_CHK']               = '';
        $aData['USE_CLIENT_NAME_DISABLED']     = ' disabled="disabled"';
        $aMR['mod_rewrite']['use_client']      = 0;
        $aData['USE_CLIENT_NAME_CHK']          = '';
        $aMR['mod_rewrite']['use_client_name'] = 0;
    }

    // use lowercase uri
    if (mr_arrayValue($request, 'use_lowercase_uri') == 1) {
        $aData['USE_LOWERCASE_URI_CHK']          = ' checked="checked"';
        $aMR['mod_rewrite']['use_lowercase_uri'] = 1;
    } else {
        $aData['USE_LOWERCASE_URI_CHK']          = '';
        $aMR['mod_rewrite']['use_lowercase_uri'] = 0;
    }

    $aData['CATEGORY_SEPARATOR_ATTRIB']                = '';
    $aData['CATEGORY_WORD_SEPARATOR_ATTRIB']           = '';
    $aData['ARTICLE_SEPARATOR_ATTRIB']                 = '';
    $aData['ARTICLE_WORD_SEPARATOR_ATTRIB']            = '';

    $separatorPattern = $oGlob->get('aSeparator/pattern');
    $separatorInfo    = $oGlob->get('aSeparator/info');

    $wordSeparatorPattern = $oGlob->get('aWordSeparator/pattern');
    $wordSeparatorInfo    = $oGlob->get('aWordSeparator/info');

    $categorySeperator = mr_arrayValue($request, 'category_seperator', '');
    $categoryWordSeperator = mr_arrayValue($request, 'category_word_seperator', '');
    $articleSeperator = mr_arrayValue($request, 'article_seperator', '');
    $articleWordSeperator = mr_arrayValue($request, 'article_word_seperator', '');

    // category seperator
    if ($categorySeperator == '') {
        $aData['CATEGORY_SEPARATOR_ERROR'] = _notifyBox('error', 'Bitte Trenner (' . $separatorInfo . ') f&uuml;r Kategorie angeben');
        $bError = true;
    } elseif (!preg_match($separatorPattern, $categorySeperator)) {
        $aData['CATEGORY_SEPARATOR_ERROR'] = _notifyBox('error', 'Trenner f&uuml;r Kategorie ist ung&uuml;ltig, erlaubt ist eines der Zeichen: ' . $separatorInfo);
        $bError = true;

    // category word seperator
    } elseif ($categoryWordSeperator == '') {
        $aData['CATEGORY_WORD_SEPARATOR_ERROR'] = _notifyBox('error', 'Bitte Trenner (' . $wordSeparatorInfo . ') f&uuml;r Kategoriew&ouml;rter angeben');
        $bError = true;
    } elseif (!preg_match($wordSeparatorPattern, $categoryWordSeperator)) {
        $aData['CATEGORY_WORD_SEPARATOR_ERROR'] = _notifyBox('error', 'Trenner f&uuml;r Kategoriew&ouml;rter ist ung&uuml;ltig, erlaubt ist eines der Zeichen: ' . $wordSeparatorInfo);
        $bError = true;

    // article seperator
    } elseif ($articleSeperator == '') {
        $aData['ARTICLE_SEPARATOR_ERROR'] = _notifyBox('error', 'Bitte Trenner (' . $separatorInfo . ') f&uuml;r Artikel angeben') . '<br>';
        $bError = true;
    } elseif (!preg_match($separatorPattern, $articleSeperator)) {
        $aData['ARTICLE_SEPARATOR_ERROR'] = _notifyBox('error', 'Trenner f&uuml;r Artikel ist ung&uuml;ltig, erlaubt ist eines der Zeichen: ' . $separatorInfo);
        $bError = true;

    // article word seperator
    } elseif ($articleWordSeperator == '') {
        $aData['ARTICLE_WORD_SEPARATOR_ERROR'] = _notifyBox('error', 'Bitte Trenner (' . $wordSeparatorInfo . ') f&uuml;r Artikelw&ouml;rter angeben');
        $bError = true;
    } elseif (!preg_match($wordSeparatorPattern, $articleWordSeperator)) {
        $aData['ARTICLE_WORD_SEPARATOR_ERROR'] = _notifyBox('error', 'Trenner f&uuml;r Artikelw&ouml;rter ist ung&uuml;ltig, erlaubt ist eines der Zeichen: ' . $wordSeparatorInfo);
        $bError = true;

    // category_seperator - category_word_seperator
    } elseif ($categorySeperator == $categoryWordSeperator) {
        $aData['CATEGORY_SEPARATOR_ERROR'] = _notifyBox('error', 'Trenner f&uuml;r Kategorie und Kategoriew&ouml;rter d&uuml;rfen nicht identisch sein');
        $bError = true;
    // category_seperator - article_word_seperator
    } elseif ($categorySeperator == $articleWordSeperator) {
        $aData['CATEGORY_SEPARATOR_ERROR'] = _notifyBox('error', 'Trenner f&uuml;r Kategorie und Artikelw&ouml;rter d&uuml;rfen nicht identisch sein');
        $bError = true;
    // article_seperator - article_word_seperator
    } elseif ($articleSeperator == $articleWordSeperator) {
        $aData['ARTICLE_SEPARATOR_ERROR'] = _notifyBox('error', 'Trenner f&uuml;r Kategorie-Artikel und Artikelw&ouml;rter d&uuml;rfen nicht identisch sein');
        $bError = true;
    }

    $aData['CATEGORY_SEPARATOR']                   = htmlentities($categorySeperator);
    $aMR['mod_rewrite']['category_seperator']      = $categorySeperator;
    $aData['CATEGORY_WORD_SEPARATOR']              = htmlentities($categoryWordSeperator);
    $aMR['mod_rewrite']['category_word_seperator'] = $categoryWordSeperator;
    $aData['ARTICLE_SEPARATOR']                    = htmlentities($articleSeperator);
    $aMR['mod_rewrite']['article_seperator']       = $articleSeperator;
    $aData['ARTICLE_WORD_SEPARATOR']               = htmlentities($articleWordSeperator);
    $aMR['mod_rewrite']['article_word_seperator']  = $articleWordSeperator;

    // file extension
    if (mr_arrayValue($request, 'file_extension', '') !== '') {
        if (!preg_match('/^\.([a-zA-Z0-9\-_\/])*$/', $request['file_extension'])) {
            $aData['FILE_EXTENSION_ERROR'] = _notifyBox('error', 'Die Dateiendung hat ein ung&uuml;ltiges Format, erlaubt sind die Zeichen \.([a-zA-Z0-9\-_\/])');
            $bError = true;
        }
        $aData['FILE_EXTENSION'] = htmlentities($request['file_extension']);
        $aMR['mod_rewrite']['file_extension'] = $request['file_extension'];
    } else {
        $aData['FILE_EXTENSION'] = '.html';
        $aMR['mod_rewrite']['file_extension'] = '.html';
    }

    // category resolve min percentage
    if (isset($request['category_resolve_min_percentage'])) {
        if (!is_numeric($request['category_resolve_min_percentage'])) {
            $aData['CATEGORY_RESOLVE_MIN_PERCENTAGE_ERROR'] = _notifyBox('error', 'Wert muss numerisch sein.');
            $bError = true;
        } elseif ($request['category_resolve_min_percentage'] < 0 || $request['category_resolve_min_percentage'] > 100) {
            $aData['CATEGORY_RESOLVE_MIN_PERCENTAGE_ERROR'] = _notifyBox('error', 'Wert muss zwischen 0 und 100 sein.');
            $bError = true;
        }
        $aData['CATEGORY_RESOLVE_MIN_PERCENTAGE'] = $request['category_resolve_min_percentage'];
        $aMR['mod_rewrite']['category_resolve_min_percentage'] = $request['category_resolve_min_percentage'];
    } else {
        $aData['CATEGORY_RESOLVE_MIN_PERCENTAGE'] = '75';
        $aMR['mod_rewrite']['category_resolve_min_percentage'] = '75';
    }

    // add start article name to url
    if (mr_arrayValue($request, 'add_startart_name_to_url') == 1) {
        $aData['ADD_STARTART_NAME_TO_URL_CHK']          = ' checked="checked"';
        $aMR['mod_rewrite']['add_startart_name_to_url'] = 1;
        if (mr_arrayValue($request, 'add_startart_name_to_url', '') !== '') {
            if (!preg_match('/^[a-zA-Z0-9\-_\/\.]*$/', $request['default_startart_name'])) {
                $aData['ADD_STARTART_NAME_TO_URL_ERROR'] = _notifyBox('error', 'Der Artikelname hat ein ung&uuml;ltiges Format, erlaubt sind die Zeichen /^[a-zA-Z0-9\-_\/\.]*$/');
                $bError = true;
            }
            $aData['DEFAULT_STARTART_NAME']              = htmlentities($request['default_startart_name']);
            $aMR['mod_rewrite']['default_startart_name'] = $request['default_startart_name'];
        } else {
            $aData['DEFAULT_STARTART_NAME']              = '';
            $aMR['mod_rewrite']['default_startart_name'] = '';
        }
    } else {
        $aData['ADD_STARTART_NAME_TO_URL_CHK']          = '';
        $aMR['mod_rewrite']['add_startart_name_to_url'] = 0;
        $aData['DEFAULT_STARTART_NAME']                 = '';
        $aMR['mod_rewrite']['default_startart_name']    = '';
    }

    // rewrite urls at
    if (mr_arrayValue($request, 'rewrite_urls_at') == 'congeneratecode') {
        $aData['REWRITE_URLS_AT_CONGENERATECODE_CHK']               = ' checked="checked"';
        $aData['REWRITE_URLS_AT_FRONT_CONTENT_OUTPUT_CHK']          = '';
        $aMR['mod_rewrite']['rewrite_urls_at_congeneratecode']      = 1;
        $aMR['mod_rewrite']['rewrite_urls_at_front_content_output'] = 0;
    } else {
        $aData['REWRITE_URLS_AT_CONGENERATECODE_CHK']               = '';
        $aData['REWRITE_URLS_AT_FRONT_CONTENT_OUTPUT_CHK']          = ' checked="checked"';
        $aMR['mod_rewrite']['rewrite_urls_at_congeneratecode']      = 0;
        $aMR['mod_rewrite']['rewrite_urls_at_front_content_output'] = 1;
    }

    // routing
    if (isset($request['rewrite_routing'])) {
        $aRouting = array();
        $items = explode("\n", $request['rewrite_routing']);
        foreach ($items as $p => $v) {
            $routingDef = explode($oGlob->get('routingSeparator'), $v);
            if (count($routingDef) !== 2) {
                continue;
            }
            $routingDef[0] = trim($routingDef[0]);
            $routingDef[1] = trim($routingDef[1]);
            if ($routingDef[0] == '') {
                continue;
            }
            $aRouting[$routingDef[0]] = $routingDef[1];
        }
        $aData['REWRITE_ROUTING']      = htmlentities($request['rewrite_routing']);
        $aMR['mod_rewrite']['routing'] = $aRouting;
    } else {
        $aData['REWRITE_ROUTING']      = '';
        $aMR['mod_rewrite']['routing'] = array();
    }

    // redirect invalid article to errorsite
    if (isset($request['redirect_invalid_article_to_errorsite'])) {
        $aData['REDIRECT_INVALID_ARTICLE_TO_ERRORSITE_CHK']          = ' checked="checked"';
        $aMR['mod_rewrite']['redirect_invalid_article_to_errorsite'] = 1;
    } else {
        $aData['REDIRECT_INVALID_ARTICLE_TO_ERRORSITE_CHK']          = '';
        $aMR['mod_rewrite']['redirect_invalid_article_to_errorsite'] = 0;
    }

    if ($bError) {
        $aData['CONTENT.BEFORE'] = _notifyBox('error', 'Bitte &uuml;berpr&uuml;fen Sie ihre Eingaben');
        $oGlob->set('aData', $aData);
        return;
    }

    if ($oGlob->get('debug') == true) {
        echo _notifyBox('info', 'Debug');
        echo '<pre class="example">';print_r($aMR['mod_rewrite']);echo '</pre>';
        echo _notifyBox('info', 'Konfiguration wurde <b>nicht</b> gespeichert, weil debugging aktiv ist');
        return;
    }

    $bSeparatorModified = _separatorModified($aMR['mod_rewrite']);

    $options['key'] = $cfg['path']['contenido'] . $cfg['path']['plugins'] . 'mod_rewrite/includes/config.mod_rewrite_' . $oGlob->get('client') . '.php';

    $config = ConfigFactory::get('filestorage', $options);

    if ($config->set($aMR)) {
        $sMsg = 'Konfiguration wurde gespeichert';
        if ($bSeparatorModified) {
            mr_loadConfiguration($oGlob->get('client'), true);
        }
        $aData['CONTENT.BEFORE'] = _notifyBox('info', $sMsg);
    } else {
        $aData['CONTENT.BEFORE'] = _notifyBox('error', 'Konfiguration konnte nicht gespeichert werden. &Uuml;berpr&uuml;fen Sie bitte die Schreibrechte f&uuml;r ' . $options['key']);
    }

    $oGlob->set('aData', $aData);
}


function _actionReset(){
    ModRewrite::resetAliases();
    $oGlob = mpGlobals::getInstance();
    $oGlob->set('aData/CONTENT.BEFORE', _notifyBox('info', 'Aliase wurden zur&uuml;ckgesetzt'));
}


function _separatorModified(&$aNewCfg){
    $aCfg = ModRewrite::getConfig();

    if ($aCfg['category_seperator'] != $aNewCfg['category_seperator']) {
        return true;
    } elseif ($aCfg['category_word_seperator'] != $aNewCfg['category_word_seperator']) {
        return true;
    } elseif ($aCfg['article_seperator'] != $aNewCfg['article_seperator']) {
        return true;
    } elseif ($aCfg['article_word_seperator'] != $aNewCfg['article_word_seperator']) {
        return true;
    }
    return false;
}


function _notifyBox($type, $msg) {
    $oNotification = mpGlobals::getInstance()->get('notification');
    return $oNotification->returnNotification($type, $msg) . '<br>';
}